/* Sergio Nuñez Covarrubias */

#ifndef Nets_H
#define Nets_H

#include "smile/smile.h"
#include "SimpleTerrain.H"


class Nets {

public:

	/* Prototipo del metodo init */
	void init();
	
	/* Prototipo del metodo getValueAttack */
	float getValueAttack(float force, float localized, float finished, float attacking);
	
	/* Prototipo del metodo getValueDefense */
	float getValueDefense(float enemyAttack, float building, float longTime, float finished, float playerAttack);
	
	/* Prototipo del metodo getValueBuildingBarracks */
	float getValueBuildingBarracks(float few, float yesBarracks, float yesBuildingNow, float finished,
								   float yesMoreBases, float small, float yesControlCenter, float yesWorker);
	
	/* Prototipo del metodo getValueBuildingFactory */
	float getValueBuildingFactory(float few, float yesFactory, float yesBuildingNow, float finished,
								  float yesBarracks, float yesControlCenter, float yesWorker);
	
	/* Prototipo del metodo getValueTrainingWorker */
	float getValueTrainingWorker(float few, float finished, float yesControlCenter, float yesCanGather, float full);
	
	/* Prototipo del metodo getValueTrainingUnit */
	float getValueTrainingUnit(float min, float ko, float few, float finished, float yesBuilding, float noFull);
	
	/* Prototipo del metodo getValueNewBase */
	float getValueNewBase(float few, float force, float small, float yesMoreBases, float yesInProgress,
						  float finished, float yesPossible, float yesWorker);
						  
	/* Prototipo del metodo getForce */
	float getForce(size_t nMarines, size_t nTanks);
	
	/* Prototipo del metodo getTime */
	float getTime(int32_t frame);
	
	/* Prototipo del metodo getLastAttack */
	float getLastAttack(int32_t frameLastAttack, int32_t frame);
	
	/* Prototipo del metodo getMineralsBuildingFew */
	float getMineralsBuildingFew(uint32_t minerals);
	
	/* Prototipo del metodo getSmallDistanceToEnemyBase */
	float getSmallDistanceToEnemyBase(TerrainBase::Loc centreLoc, Vector<ScalarPoint> locationsEnemyBuilding);
	
	/* Prototipo del metodo getMineralsTRainingFew */
	float getMineralsTrainingFew(uint32_t minerals);
	
	/* Prototipo del metodo getMinNumberOfUnit */
	float getMinNumberOfUnit(const std::string & bp_name, size_t count);
	
	/* Prototipo del metodo getKoRatio */
	float getKoRatio(const std::string & bp_name, size_t countMarines, size_t countTanks);	
	
};

#endif