/* Sergio Nuñez Covarrubias */

#ifndef NewBase_H
#define NewBase_H

#include "SpecialDefenseCommander.H"
#include "Finance.H"
#include <iostream.h>

/* Clase NewBase */
class NewBase : public SpecialCommander{

public:

	/* Prototipo del constructor  */
	NewBase(ModuleSet & ms, Vector<GameObj*> units, GameObj* gob, TerrainBase::Loc centroidCluster, 
			TerrainBase::Loc locBuildingEnemy, Finance::Ticket * reserve);
			
	/* Prototipo del metodo run */
	bool run();
	
	/* Prototipo del metodo getLoc */
	TerrainBase::Loc getLoc();
	
	/* Prototipo del metodo isFinish */
	bool isFinish();
	
	/* Prototipo del metodo removeWorker */
	GameObj* removeWorker();
	
	/* Prototipo del metodo removeDefense */
	Vector<GameObj*> removeDefense();
	
	/* Prototipo del metodo retry */
	bool retry();
	
	/* Prototipo del metodo addNewWorker */
	void addNewWorker(GameObj* gob);
	
	/* Prototipo del metodo cambiarUnidad */
	bool getCambiarUnidad();
	
	/* Prototipo del metodo getFounds */
	Finance::Ticket * getFunds();
			
private:

	/* Objeto para la defense */
	SpecialDefenseCommander * defense;
	
	/* Unidad worker para la construccion del cc */
	GameObj* worker;
	
	/* Posicion del cluster de minerales cercano a la nueva base */
	const TerrainBase::Loc locCluster;
	
	/* Posicion de la base enemiga mas cercana */
	const TerrainBase::Loc locEnemy;
	
	/* Indica si el procedimiento ha finalizado */
	bool finish;
	
	/* Indica si la unidad worker esta en movimiento */
	bool running;
	
	/* Modulo de apoyo para el moviemiento de las unidades */
	Movement::Context mc;
	
	/* Indica la direccion en la que se tiene que construir la base */
	std::string pos;
	
	/* Posisicion objetivo */
	TerrainBase::Loc target;
	
	/* Contador auxiliar para el movimiento de la unidad worker */
	int contador;
	
	/* Indica si se le esta dando un nuevo objetivo a las unidades militares */
	bool move;
	
	/* Indica si la unidad worker ha llegado a su destino */
	bool workerMoved;
	
	/* Indica la accion actual del procedimiento */
	int action;
	
	/* Contador auxiliar para el movimiento de la unidad worker */
	int contador2;
	
	/* Inica si hay que cambiar la unidad worker */
	bool cambiarUnidad;
	
	/* Ticket que contiene la cantidad de minerales que cuesta construir el cc  */
	Finance::Ticket * funds;

	/* Prototipo del metodo init */
	void init(Vector<GameObj*> units);
		
	/* Prototipo del metodo moveDefense */
	void moveDefense();
	
	/* Prototipo del metodo moveWorker */
	void moveWorker();		
	
	/* Prototipo del metodo getTile */
	TerrainBase::Loc getTile(TerrainBase::Loc point);
	
	/* Prototipo del metodo getDistanceToTarget */
	real8 getDistanceToTarget(TerrainBase::Loc target, sint4 x, sint4 y);	
	
	/* Prototipo del metodo onLoseUnit */
	void onLoseUnit( GameObj * unit );
	
	/* Prototipo del metodo exec */
	void exec();
	
	/* Prototipo del metodo onReceiveUnit */
	void onReceiveUnit( GameObj * unit, Watcher::WatchID );
	
	/* Prototipo del metodo onEvent */
    bool onEvent(const Event &event);
};

#endif
