/* Sergio Nuñez Covarrubias */
 
#ifndef SpecialScouting_H
#define SpecialScouting_H

#include "Game.H"
#include "GameObj.H"
#include "Movement.h"
#include "ModuleSet.h"
#include "EventHandler.H"
#include "Watcher.H"


/* Estructura para realizar el scauting */
struct Scouting{
	
	/* Scaut */
	GameObj * scout;
	
	/* Destino del scaut */
	ScalarPoint target;
	
	/* true si ha llegado al destino */
	bool running;
	
	short contador;
	
	/* Constructor */
	Scouting(GameObj * scout_){
		scout = scout_;
		contador = 0;
		running = false;		
	}
};



/* Clase SpecialScouting */
class SpecialScouting : EventHandler{

public:	
		
	/* Prototipo del metodo addScout */
	void addScout(GameObj* gob);
	
	/* Prototipo del metodo removeScout */
	GameObj* removeScout();
	
	/* Prototipo del metodo getNumberScouts */
	unsigned getNumberScouts();

	/* Prototipo del metodo scouting */
	void scouting(const Map<GameTile> &map);
	
	/* Prototipo del metodo onLoseUnit */
	void onLoseUnit(GameObj * unit);
	
	/* Prototipo del metodo handle_event */
	bool handle_event(const Event &event);
	
	/* Constructor */
	SpecialScouting(sint4 seed, ModuleSet & msGeneral, ModuleSet & msGather):
	 mc(msGeneral.get_movement(), "Default", "Default"), moduleSet(msGather){
		rand.srand(seed);
	}

private:

	/* Conjunto de estructuras Scouting para realizar la tarea scouting */
	Vector<Scouting> scouts;		
	
	/* Objeto Random para obtener numeros aleatorios */
	Random rand;
	
	/* Modulo de apaoyo para el movimiento */
	Movement::Context mc;
	
	/* Conjunto de modulos de apoyo */
	ModuleSet & moduleSet;
	
	/* Prototipo del metodo getTargetTile */
	ScalarPoint getTargetTile(const Map<GameTile> &map);
	
	/* Prototipo del metodo getDistanceToTarget */
	real8 getDistanceToTarget(ScalarPoint targetScaut, sint4 x, sint4 y);
	
	/* Prototipo del metodo removeScout */
	void removeScout(GameObj* gob);	
};

#endif